#region Copyright  2004 Victor Boctor
//
// MantisConnect is copyrighted to Victor Boctor
//
// This program is distributed under the terms and conditions of the GPL
// See LICENSE file for details.
//
// For commercial applications to link with or modify MantisConnect, they require the
// purchase of a MantisConnect commerical license.
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Configuration;
using System.ComponentModel;
using System.Net;
using System.Windows.Forms;

using Futureware.MantisConnect;

namespace Futureware.MantisSubmit
{
	/// <summary>
	/// A Windows form that allows submitting of issues in a Mantis installation.
	/// </summary>
	public class SubmitIssueForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Button submitButton;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.ComboBox priorityComboBox;
        private System.Windows.Forms.ComboBox severityComboBox;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.ComboBox reproducibilityComboBox;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.TextBox summaryTextBox;
        private System.Windows.Forms.TextBox descriptionTextBox;
        private System.Windows.Forms.ComboBox projectComboBox;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.StatusBar statusBar;
        private System.Windows.Forms.ComboBox versionComboBox;
        private System.Windows.Forms.Label label8;
        private System.Windows.Forms.ComboBox categoryComboBox;
        private System.Windows.Forms.Label label9;
        private System.Windows.Forms.StatusBarPanel statusBarPanel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SubmitIssueForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.summaryTextBox = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.submitButton = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.priorityComboBox = new System.Windows.Forms.ComboBox();
            this.severityComboBox = new System.Windows.Forms.ComboBox();
            this.label3 = new System.Windows.Forms.Label();
            this.reproducibilityComboBox = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.descriptionTextBox = new System.Windows.Forms.TextBox();
            this.projectComboBox = new System.Windows.Forms.ComboBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.statusBar = new System.Windows.Forms.StatusBar();
            this.versionComboBox = new System.Windows.Forms.ComboBox();
            this.label8 = new System.Windows.Forms.Label();
            this.categoryComboBox = new System.Windows.Forms.ComboBox();
            this.label9 = new System.Windows.Forms.Label();
            this.statusBarPanel = new System.Windows.Forms.StatusBarPanel();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel)).BeginInit();
            this.SuspendLayout();
            // 
            // summaryTextBox
            // 
            this.summaryTextBox.Location = new System.Drawing.Point(160, 272);
            this.summaryTextBox.Name = "summaryTextBox";
            this.summaryTextBox.Size = new System.Drawing.Size(472, 20);
            this.summaryTextBox.TabIndex = 7;
            this.summaryTextBox.Text = "";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(32, 272);
            this.label1.Name = "label1";
            this.label1.TabIndex = 1;
            this.label1.Text = "Summary";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // submitButton
            // 
            this.submitButton.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.submitButton.Location = new System.Drawing.Point(304, 496);
            this.submitButton.Name = "submitButton";
            this.submitButton.TabIndex = 9;
            this.submitButton.Text = "Submit";
            this.submitButton.Click += new System.EventHandler(this.submitButton_Click);
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(32, 176);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 21);
            this.label2.TabIndex = 3;
            this.label2.Text = "Priority";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // priorityComboBox
            // 
            this.priorityComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.priorityComboBox.Location = new System.Drawing.Point(160, 176);
            this.priorityComboBox.Name = "priorityComboBox";
            this.priorityComboBox.Size = new System.Drawing.Size(176, 21);
            this.priorityComboBox.TabIndex = 4;
            // 
            // severityComboBox
            // 
            this.severityComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.severityComboBox.Location = new System.Drawing.Point(160, 208);
            this.severityComboBox.Name = "severityComboBox";
            this.severityComboBox.Size = new System.Drawing.Size(176, 21);
            this.severityComboBox.TabIndex = 5;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(32, 208);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 21);
            this.label3.TabIndex = 5;
            this.label3.Text = "Severity";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // reproducibilityComboBox
            // 
            this.reproducibilityComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.reproducibilityComboBox.Location = new System.Drawing.Point(160, 240);
            this.reproducibilityComboBox.Name = "reproducibilityComboBox";
            this.reproducibilityComboBox.Size = new System.Drawing.Size(176, 21);
            this.reproducibilityComboBox.TabIndex = 6;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(32, 240);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(100, 21);
            this.label4.TabIndex = 7;
            this.label4.Text = "Reproducibility";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(32, 304);
            this.label5.Name = "label5";
            this.label5.TabIndex = 10;
            this.label5.Text = "Description";
            this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // descriptionTextBox
            // 
            this.descriptionTextBox.Location = new System.Drawing.Point(160, 304);
            this.descriptionTextBox.Multiline = true;
            this.descriptionTextBox.Name = "descriptionTextBox";
            this.descriptionTextBox.Size = new System.Drawing.Size(472, 176);
            this.descriptionTextBox.TabIndex = 8;
            this.descriptionTextBox.Text = "";
            // 
            // projectComboBox
            // 
            this.projectComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.projectComboBox.Location = new System.Drawing.Point(160, 80);
            this.projectComboBox.Name = "projectComboBox";
            this.projectComboBox.Size = new System.Drawing.Size(176, 21);
            this.projectComboBox.TabIndex = 1;
            this.projectComboBox.SelectedIndexChanged += new System.EventHandler(this.projectComboBox_SelectedIndexChanged);
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(32, 80);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(100, 21);
            this.label6.TabIndex = 11;
            this.label6.Text = "Project";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 20.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.label7.Location = new System.Drawing.Point(32, 16);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(616, 48);
            this.label7.TabIndex = 13;
            this.label7.Text = "MantisConnect Submit";
            // 
            // statusBar
            // 
            this.statusBar.Location = new System.Drawing.Point(0, 536);
            this.statusBar.Name = "statusBar";
            this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
                                                                                         this.statusBarPanel});
            this.statusBar.ShowPanels = true;
            this.statusBar.Size = new System.Drawing.Size(664, 22);
            this.statusBar.TabIndex = 14;
            // 
            // versionComboBox
            // 
            this.versionComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.versionComboBox.Location = new System.Drawing.Point(160, 112);
            this.versionComboBox.Name = "versionComboBox";
            this.versionComboBox.Size = new System.Drawing.Size(176, 21);
            this.versionComboBox.TabIndex = 2;
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(32, 112);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(100, 21);
            this.label8.TabIndex = 16;
            this.label8.Text = "Version";
            this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // categoryComboBox
            // 
            this.categoryComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.categoryComboBox.Location = new System.Drawing.Point(160, 144);
            this.categoryComboBox.Name = "categoryComboBox";
            this.categoryComboBox.Size = new System.Drawing.Size(176, 21);
            this.categoryComboBox.TabIndex = 3;
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(32, 144);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(100, 21);
            this.label9.TabIndex = 18;
            this.label9.Text = "Category";
            this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // statusBarPanel
            // 
            this.statusBarPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
            this.statusBarPanel.Width = 648;
            // 
            // SubmitIssueForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(664, 558);
            this.Controls.Add(this.categoryComboBox);
            this.Controls.Add(this.label9);
            this.Controls.Add(this.versionComboBox);
            this.Controls.Add(this.label8);
            this.Controls.Add(this.statusBar);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.projectComboBox);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.descriptionTextBox);
            this.Controls.Add(this.summaryTextBox);
            this.Controls.Add(this.reproducibilityComboBox);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.severityComboBox);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.priorityComboBox);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.submitButton);
            this.Controls.Add(this.label1);
            this.Name = "SubmitIssueForm";
            this.Text = "Mantis Connect - Submit Issue";
            this.Load += new System.EventHandler(this.SubmitIssue_Load);
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

        private void SubmitIssue_Load(object sender, System.EventArgs e)
        {
            try
            {
                NetworkCredential nc = null;

                string basicHttpAuthUserName = ConfigurationSettings.AppSettings["BasicHttpAuthUserName"];
                string basicHttpAuthPassword = ConfigurationSettings.AppSettings["BasicHttpAuthPassword"];
                if ( ( basicHttpAuthUserName != null ) && ( basicHttpAuthUserName.Length > 0 ) && ( basicHttpAuthPassword != null ) )
                    nc = new NetworkCredential( basicHttpAuthUserName, basicHttpAuthPassword );

                string mantisConnectUrl = ConfigurationSettings.AppSettings["MantisConnectUrl"];
                string mantisUserName = ConfigurationSettings.AppSettings["MantisUserName"];
                string mantisPassword = ConfigurationSettings.AppSettings["MantisPassword"];

                session = new Session( mantisConnectUrl, mantisUserName, mantisPassword, nc );

                session.Connect();

                populating = true;
                projectComboBox.DataSource = session.Request.UserGetAccesibleProjects();
                projectComboBox.DisplayMember = "Name";
                projectComboBox.ValueMember = "Id";
                populating = false;

                projectComboBox.SelectedIndex = 0;
                PopulateProjectDependentFields();

                priorityComboBox.DataSource = session.Config.PriorityEnum.Labels;
                severityComboBox.DataSource = session.Config.SeverityEnum.Labels;
                reproducibilityComboBox.DataSource = session.Config.ReproducibilityEnum.Labels;
            }
            catch( Exception ex )
            {
                MessageBox.Show( ex.Message, "Webservice Error", MessageBoxButtons.OK, MessageBoxIcon.Stop );
            }
            catch
            {
                MessageBox.Show( "Unknown Exception", "Webservice Error", MessageBoxButtons.OK, MessageBoxIcon.Stop );
            }
        }

        /// <summary>
        /// Event handler for clicking the submit button.
        /// </summary>
        /// <param name="sender">not used</param>
        /// <param name="e">not used</param>
        private void submitButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                statusBar.Panels[0].Text = "Checking if issue already reported...";

                // Check if issue was previously logged in Mantis.
                int issueId = session.Request.IssueGetIdFromSummary( summaryTextBox.Text );
                if ( issueId > 0 )
                {
                    statusBar.Panels[0].Text = string.Format( "'{0}' already reported in issue {1}", summaryTextBox.Text, issueId );
                    return;
                }

                // Create the issue in memory
                Issue issue = new Issue();

                issue.Project = new ObjectRef( projectComboBox.Text );
                issue.Priority = new ObjectRef( priorityComboBox.Text );
                issue.Severity = new ObjectRef( severityComboBox.Text );
                issue.Reproducibility = new ObjectRef( reproducibilityComboBox.Text );
                issue.Category = new ObjectRef( categoryComboBox.Text );
                issue.ProductVersion = versionComboBox.Text;
                issue.Summary = summaryTextBox.Text;
                issue.Description = descriptionTextBox.Text;
                issue.ReportedBy = new User();
				issue.ReportedBy.Name = session.Username;

                statusBar.Panels[0].Text = "Submitting issue...";

                // Submit the issue and show its id in the status bar
                statusBar.Panels[0].Text = string.Format( "Issued added as {0}.", session.Request.IssueAdd( issue ) );

                ResetForm();
            }
            catch( Exception ex )
            {
                MessageBox.Show( ex.Message, "Webservice Error", MessageBoxButtons.OK, MessageBoxIcon.Stop );
                statusBar.Text = string.Empty;
            }
            catch
            {
                MessageBox.Show( "Unknown Exception", "Webservice Error", MessageBoxButtons.OK, MessageBoxIcon.Stop );
                statusBar.Text = string.Empty;
            }
        }

        /// <summary>
        /// Prepare the form for the next issue.
        /// </summary>
        private void ResetForm()
        {
            summaryTextBox.Clear();
            summaryTextBox.Focus();
            descriptionTextBox.Clear();
        }

        /// <summary>
        /// Event handler for selection change for the current project.
        /// </summary>
        /// <param name="sender">not used</param>
        /// <param name="e">not used</param>
        private void projectComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if ( populating )
                return;

            PopulateProjectDependentFields();
        }

        /// <summary>
        /// Populates the list of categories and versions based on the currently
        /// selected projects.
        /// </summary>
        private void PopulateProjectDependentFields()
        {
            try
            {
                int projectId = (int)projectComboBox.SelectedValue;

				if ( projectId == 0 )
				{
					categoryComboBox.DataSource = null;
					versionComboBox.DataSource = null;
				}
				else
				{
					categoryComboBox.DataSource = session.Request.ProjectGetCategories( projectId );
					categoryComboBox.DisplayMember = "Name";
					versionComboBox.DataSource = session.Request.ProjectGetVersions( projectId );
					versionComboBox.DisplayMember = "Name";
				}
            }
            catch( Exception ex )
            {
                MessageBox.Show( ex.Message, "Webservice Error", MessageBoxButtons.OK, MessageBoxIcon.Stop );
            }
            catch
            {
                MessageBox.Show( "Unknown Exception", "Webservice Error", MessageBoxButtons.OK, MessageBoxIcon.Stop );
            }
        }

        /// <summary>
        /// Tracks whether the projects combobox is currently being populated or not.
        /// </summary>
        /// <remarks>
        /// If being populated, then selection change event for the current project is
        /// ignored.
        /// </remarks>
        private bool populating = false;

        /// <summary>
        /// Session used to communicate with MantisConnect.
        /// </summary>
        private Session session;
    }
}
