#region Copyright  2004 Victor Boctor
//
// MantisConnect is copyrighted to Victor Boctor
//
// This program is distributed under the terms and conditions of the GPL
// See LICENSE file for details.
//
// For commercial applications to link with or modify MantisConnect, they require the
// purchase of a MantisConnect commerical license.
//
#endregion

using System;
using System.Net;
using System.Web.Services.Protocols;

using NUnit.Framework;

namespace Futureware.MantisConnect.UnitTests
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	[TestFixture]
	public sealed class RetrieveEnums : BaseTestFixture
	{
		[TestFixtureSetUp]
		public void TestFixtureSetup()
		{
			Connect();
		}

		[TestFixtureTearDown]
		public void TestFixtureTearDown()
		{
		}

		[Test]
		public void StatusEnum()
		{
			MantisEnum statusEnum = Session.Config.StatusEnum;
			Assert.IsTrue( statusEnum.Labels.Length > 0 );
			WriteEnum( "Status", statusEnum );
		}

		[Test]
		public void PriorityEnum()
		{
			MantisEnum priorityEnum = Session.Config.PriorityEnum;
			Assert.IsTrue( priorityEnum.Labels.Length > 0 );
			WriteEnum( "Priority", priorityEnum );
		}

		[Test]
		public void SeverityEnum()
		{
			MantisEnum severityEnum = Session.Config.SeverityEnum;
			Assert.IsTrue( severityEnum.Labels.Length > 0 );
			WriteEnum( "Severity", severityEnum );
		}

		[Test]
		public void ProjectionEnum()
		{
			MantisEnum projectionEnum = Session.Config.ProjectionEnum;
			Assert.IsTrue( projectionEnum.Labels.Length > 0 );
			WriteEnum( "Projection", projectionEnum );
		}

		[Test]
		public void EtaEnum()
		{
			MantisEnum etaEnum = Session.Config.EtaEnum;
			Assert.IsTrue( etaEnum.Labels.Length > 0 );
			WriteEnum( "Eta", etaEnum );
		}

		[Test]
		public void ReproducibilityEnum()
		{
			MantisEnum reproducibilityEnum = Session.Config.ReproducibilityEnum;
			Assert.IsTrue( reproducibilityEnum.Labels.Length > 0 );
			WriteEnum( "Reproducibility", reproducibilityEnum );
		}

		[Test]
		public void AccessLevelEnum()
		{
			MantisEnum accessLevelEnum = Session.Config.AccessLevelEnum;
			Assert.IsTrue( accessLevelEnum.Labels.Length > 0 );
			WriteEnum( "AccessLevel", accessLevelEnum );
		}

		[Test]
		public void ResolutionEnum()
		{
			MantisEnum resolutionEnum = Session.Config.ResolutionEnum;
			Assert.IsTrue( resolutionEnum.Labels.Length > 0 );
			WriteEnum( "Resolution", resolutionEnum );
		}

		[Test]
		public void ViewStateEnum()
		{
			MantisEnum viewStateEnum = Session.Config.ViewStateEnum;
			Assert.IsTrue( viewStateEnum.Labels.Length > 0 );
			WriteEnum( "ViewState", viewStateEnum );
		}

		private void WriteEnum( string enumType, MantisEnum mantisEnum )
		{
			Console.WriteLine();
			Console.WriteLine( enumType );

			string[] labels = mantisEnum.Labels;
			
			foreach( string label in labels )
				Console.WriteLine( label );
		}
	}
}
