#region Copyright  2004 Victor Boctor
//
// MantisConnect is copyrighted to Victor Boctor
//
// This program is distributed under the terms and conditions of the GPL
// See LICENSE file for details.
//
// For commercial applications to link with or modify MantisConnect, they require the
// purchase of a MantisConnect commerical license.
//
#endregion

using System;

namespace Futureware.MantisConnect
{
	/// <summary>
	/// 
	/// </summary>
	public class ProjectVersion
	{
		/// <summary>
		/// 
		/// </summary>
		public ProjectVersion()
		{
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="projectVersionData"></param>
		/// <exception cref="FormatException"></exception>
		internal ProjectVersion( MantisConnectWebservice.ProjectVersionData projectVersionData )
		{
			this.Id = Convert.ToInt32( projectVersionData.id );
			this.Name = projectVersionData.name;
			this.ProjectId = Convert.ToInt32( projectVersionData.project_id );
			this.DateOrder = projectVersionData.date_order;
			this.Description = projectVersionData.description;
			this.IsReleased = projectVersionData.released;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="projectVersionDataArray"></param>
		/// <returns></returns>
		internal static ProjectVersion[] ConvertArray( MantisConnectWebservice.ProjectVersionData[] projectVersionDataArray )
		{
			if ( projectVersionDataArray == null )
				return null;

			ProjectVersion[] projectVersions = new ProjectVersion[projectVersionDataArray.Length];

			for ( int i = 0; i < projectVersionDataArray.Length; ++i )
				projectVersions[i] = new ProjectVersion( projectVersionDataArray[i] );

			return projectVersions;
		}

		/// <summary>
		/// 
		/// </summary>
		public int Id
		{
			get { return id; }
			set { id = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		public string Name
		{
			get { return name; }
			set { name = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		public int ProjectId
		{
			get { return projectId; }
			set { projectId = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		public DateTime DateOrder
		{
			get { return dateOrder; }
			set { dateOrder = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		public string Description
		{
			get { return description; }
			set { description = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		public bool IsReleased
		{
			get { return isReleased; }
			set { isReleased = value; }
		}

		#region Private Members
		private int id;
		private string name;
		private int projectId;
		private DateTime dateOrder;
		private string description;
		private bool isReleased;
		#endregion
	}
}
