<?php
	# MantisConnect - a Dot Net library to connect to Mantis Bug Tracker
	# Copyright (C) 2004-2005  Victor Boctor - vboctor@users.sourceforge.net
	# This program is distributed under dual licensing.  These include
	# GPL and a commercial licenses.  Victor Boctor reserves the right to
	# change the license of future releases.
	# See docs/ folder for more details

	# --------------------------------------------------------
	# $Id: mantisconnect.php,v 1.31 2005/06/17 14:44:39 vboctor Exp $
	# --------------------------------------------------------

	$t_current_dir = dirname( __FILE__ ) . DIRECTORY_SEPARATOR;
	$t_nusoap_dir  = $t_current_dir . 'nusoap';

	# includes nusoap classes
	chdir( $t_nusoap_dir );
	require_once( 'nusoap.php' );
	chdir( $t_current_dir );

	# create server
	$l_oServer = new soap_server();

	# namespace
	$t_namespace = 'http://futureware.biz/mantisconnect';

	# wsdl generation
	$l_oServer->debug_flag = false;
	$l_oServer->configureWSDL( 'MantisConnect', $t_namespace );
	$l_oServer->wsdl->schemaTargetNamespace = $t_namespace;


	###
	###  PUBLIC TYPES
	###

	### StringArray
	$l_oServer->wsdl->addComplexType(
		'StringArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'xsd:string[]'
		)),
		'xsd:string'
	);


	### ObjectRef
	$l_oServer->wsdl->addComplexType(
		'ObjectRef',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'	=>	array( 'name' => 'id',		'type' => 'xsd:integer'),
			'name'	=>	array( 'name' => 'name',	'type' => 'xsd:string')
		)
	);

	### ObjectRefArray
	$l_oServer->wsdl->addComplexType(
		'ObjectRefArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:ObjectRef[]'
		)),
		'tns:ObjectRef'
	);


	### AccountData
	$l_oServer->wsdl->addComplexType(
		'AccountData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'		=>	array( 'name' => 'id',			'type' => 'xsd:integer'),
			'name'		=>	array( 'name' => 'name',		'type' => 'xsd:string'),
			'real_name'	=>	array( 'name' => 'real_name',	'type' => 'xsd:string'),
			'email'		=>	array( 'name' => 'email',		'type' => 'xsd:string')
		)
	);

	### AccountDataArray
	$l_oServer->wsdl->addComplexType(
		'AccountDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:AccountData[]'
		)),
		'tns:AccountData'
	);


	### AttachmentData
	$l_oServer->wsdl->addComplexType(
		'AttachmentData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'				=>	array( 'name' => 'id',				'type' => 'xsd:integer'),
			'filename'			=>	array( 'name' => 'filename',		'type' => 'xsd:string'),
			'size'				=>	array( 'name' => 'size',			'type' => 'xsd:integer'),
			'content_type'		=>	array( 'name' => 'content_type',	'type' => 'xsd:string'),
			'date_submitted'	=>	array( 'name' => 'date_submitted',	'type' => 'xsd:dateTime'),
			'download_url'		=>	array( 'name' => 'download_url',	'type' => 'xsd:anyURI')
		)
	);


	### AttachmentDataArray
	$l_oServer->wsdl->addComplexType(
		'AttachmentDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:AttachmentData[]'
		)),
		'tns:AttachmentData'
	);


	### RelationshipData
	$l_oServer->wsdl->addComplexType(
		'RelationshipData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'type'		=>	array( 'name' => 'type',		'type' => 'tns:ObjectRef'),
			'target_id'	=>	array( 'name' => 'target_id',	'type' => 'xsd:integer')
		)
	);

	### RelationshipDataArray
	$l_oServer->wsdl->addComplexType(
		'RelationshipDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:RelationshipData[]'
		)),
		'tns:RelationshipData'
	);


	### IssueNoteData
	$l_oServer->wsdl->addComplexType(
		'IssueNoteData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'				=>	array( 'name' => 'id',				'type' => 'xsd:integer'),
			'reporter'			=>	array( 'name' => 'reporter',		'type' => 'tns:AccountData'),
			'text'				=>	array( 'name' => 'text',			'type' => 'xsd:string'),
			'view_state'		=>	array( 'name' => 'view_state',		'type' => 'tns:ObjectRef'),
			'date_submitted'	=>	array( 'name' => 'date_submitted',	'type' => 'xsd:dateTime'),
			'last_modified'		=>	array( 'name' => 'last_modified',	'type' => 'xsd:dateTime')
		)
	);


	### IssueNoteDataArray
	$l_oServer->wsdl->addComplexType(
		'IssueNoteDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:IssueNoteData[]'
		)),
		'tns:IssueNoteData'
	);


	### IssueData
	$l_oServer->wsdl->addComplexType(
		'IssueData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'			=>	array( 'name' => 'id',				'type' => 'xsd:integer' ),
			'view_state'	=>	array( 'name' => 'view_state',		'type' => 'tns:ObjectRef' ),
			'last_updated'	=>	array( 'name' => 'last_updated',	'type' => 'xsd:dateTime' ),

			'project'	=>	array( 'name' => 'project',		'type' => 'tns:ObjectRef' ),
			'category'	=>	array( 'name' => 'category',	'type' => 'xsd:string' ),
			'priority'	=>	array( 'name' => 'priority',	'type' => 'tns:ObjectRef' ),
			'severity'	=>	array( 'name' => 'severity',	'type' => 'tns:ObjectRef' ),
			'status'	=>	array( 'name' => 'status',		'type' => 'tns:ObjectRef' ),

			'reporter'			=>	array( 'name' => 'reporter',		'type' => 'tns:AccountData' ),
			'summary'			=>	array( 'name' => 'summary',			'type' => 'xsd:string' ),
			'version'			=>	array( 'name' => 'version',			'type' => 'xsd:string' ),
			'build'				=>	array( 'name' => 'build',			'type' => 'xsd:string' ),
			'platform'			=>	array( 'name' => 'platform',		'type' => 'xsd:string' ),
			'os'				=>	array( 'name' => 'os',				'type' => 'xsd:string' ),
			'os_build'			=>	array( 'name' => 'os_build',		'type' => 'xsd:string' ),
			'reproducibility'	=>	array( 'name' => 'reproducibility', 'type' => 'tns:ObjectRef' ),
			'date_submitted'	=>	array( 'name' => 'date_submitted',	'type' => 'xsd:dateTime' ),

			'sponsorship_total' =>	array( 'name' => 'sponsorship_total',	'type' => 'xsd:integer' ),

			'handler'		=>	array( 'name' => 'handler',		'type' => 'tns:AccountData' ),
			'projection'	=>	array( 'name' => 'projection',	'type' => 'tns:ObjectRef' ),
			'eta'			=>	array( 'name' => 'eta',			'type' => 'tns:ObjectRef' ),

			'resolution'		=>	array( 'name' => 'resolution',		'type' => 'tns:ObjectRef' ),
			'fixed_in_version'	=>	array( 'name'=>'fixed_in_version',	'type' => 'xsd:string' ),

			'description'				=>	array( 'name' => 'description',				'type' => 'xsd:string' ),
			'steps_to_reproduce'		=>	array( 'name' => 'steps_to_reproduce',		'type' => 'xsd:string' ),
			'additional_information'	=>	array( 'name' => 'additional_information',	'type' => 'xsd:string' ),

			'attachments'				=>	array( 'name' => 'attachments', 			'type' => 'tns:AttachmentDataArray' ),
			'relationships'				=>	array( 'name' => 'relationships',			'type' => 'tns:RelationshipDataArray' ),
			'notes'						=>	array( 'name' => 'notes',					'type' => 'tns:IssueNoteDataArray' ),
			'custom_fields'				=>  array( 'name' => 'custom_fields',			'type' => 'tns:CustomFieldValueForIssueDataArray' )
		)
	);

	### IssueDataArray
	$l_oServer->wsdl->addComplexType(
		'IssueDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:IssueData[]'
		)),
		'tns:IssueData'
	);


	### ProjectData
	$l_oServer->wsdl->addComplexType(
		'ProjectData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'			=>	array( 'name' => 'id',			'type' => 'xsd:integer' ),
			'name'			=>	array( 'name' => 'name',		'type' => 'xsd:string' ),
			'status'		=>	array( 'name' => 'status',		'type' => 'tns:ObjectRef' ),
			'enabled'		=>	array( 'name' => 'enabled',		'type' => 'xsd:boolean' ),
			'view_state'	=>	array( 'name' => 'view_state',	'type' => 'tns:ObjectRef' ),
			'access_min'	=>	array( 'name' => 'access_min',	'type' => 'tns:ObjectRef' ),
			'file_path'		=>	array( 'name' => 'file_path',	'type' => 'xsd:string' ),
			'description'	=>	array( 'name' => 'description',	'type' => 'xsd:string' )
		)
	);

	### ProjectDataArray
	$l_oServer->wsdl->addComplexType(
		'ProjectDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:ProjectData[]'
		)),
		'tns:ProjectData'
	);


	### ProjectVersionData
	$l_oServer->wsdl->addComplexType(
		'ProjectVersionData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'			=>	array( 'name' => 'id',			'type' => 'xsd:integer' ),
			'name'			=>	array( 'name' => 'name',		'type' => 'xsd:string' ),
			'project_id'	=>	array( 'name' => 'project_id',	'type' => 'xsd:integer' ),
			'date_order'	=>	array( 'name' => 'date_order',	'type' => 'xsd:dateTime' ),
			'description'	=>	array( 'name' => 'description',	'type' => 'xsd:string' ),
			'released'		=>	array( 'name' => 'released',	'type' => 'xsd:boolean' )
		)
	);

	### ProjectVersionDataArray
	$l_oServer->wsdl->addComplexType(
		'ProjectVersionDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:ProjectVersionData[]'
		)),
		'tns:ProjectVersionData'
	);


	### FilterData
	$l_oServer->wsdl->addComplexType(
		'FilterData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'id'			=>	array( 'name' => 'id',				'type' => 'xsd:integer' ),
			'owner'			=>	array( 'name' => 'owner',			'type' => 'tns:AccountData' ),
			'project_id'	=>	array( 'name' => 'project_id',		'type' => 'xsd:integer' ),
			'is_public'		=>	array( 'name' => 'is_public',		'type' => 'xsd:boolean' ),
			'name'			=>	array( 'name' => 'name',			'type' => 'xsd:string' ),
			'filter_string'	=>	array( 'name' => 'filter_string',	'type' => 'xsd:string' )
		)
	);

	### FilterDataArray
	$l_oServer->wsdl->addComplexType(
		'FilterDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:FilterData[]'
		)),
		'tns:FilterData'
	);

	### CustomFieldDefinitionData
	$l_oServer->wsdl->addComplexType(
		'CustomFieldDefinitionData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'field'				=>	array( 'name' => 'field',			'type' => 'tns:ObjectRef'),
			'type'				=>	array( 'name' => 'type',			'type' => 'xsd:integer'),
			'possible_values'	=>	array( 'name' => 'possible_values',	'type' => 'xsd:string'),
			'default_value'		=>	array( 'name' => 'default_value',	'type' => 'xsd:string'),
			'valid_regexp'		=>	array( 'name' => 'valid_regexp',	'type' => 'xsd:string'),
			'access_level_r'	=>	array( 'name' => 'access_level_r',	'type' => 'xsd:integer'),
			'access_level_rw'	=>	array( 'name' => 'access_level_rw',	'type' => 'xsd:integer'),
			'length_min'		=>	array( 'name' => 'length_min',		'type' => 'xsd:integer'),
			'length_max'		=>	array( 'name' => 'length_max',		'type' => 'xsd:integer'),
			'advanced'			=>	array( 'name' => 'advanced',		'type' => 'xsd:boolean'),
			'display_report'	=>	array( 'name' => 'display_report',	'type' => 'xsd:boolean'),
			'display_update'	=>	array( 'name' => 'display_update',	'type' => 'xsd:boolean'),
			'display_resolved'	=>	array( 'name' => 'display_resolved','type' => 'xsd:boolean'),
			'display_closed'	=>	array( 'name' => 'display_closed',	'type' => 'xsd:boolean'),
			'require_report'	=>	array( 'name' => 'require_report',	'type' => 'xsd:boolean'),
			'require_update'	=>	array( 'name' => 'require_update',	'type' => 'xsd:boolean'),
			'require_resolved'	=>	array( 'name' => 'require_resolved','type' => 'xsd:boolean'),
			'require_closed'	=>	array( 'name' => 'require_closed',	'type' => 'xsd:boolean')
		)
	);


	### CustomFieldDefinitionDataArray
	$l_oServer->wsdl->addComplexType(
		'CustomFieldDefinitionDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:CustomFieldDefinitionData[]'
		)),
		'tns:CustomFieldDefinitionData'
	);


	### CustomFieldLinkForProjectData
	$l_oServer->wsdl->addComplexType(
		'CustomFieldLinkData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'field'				=>	array( 'name' => 'field',			'type' => 'tns:ObjectRef'),
			'sequence'			=>	array( 'name' => 'sequence',		'type' => 'xsd:byte')
		)
	);


	### CustomFieldLinkForProjectDataArray
	$l_oServer->wsdl->addComplexType(
		'CustomFieldLinkForProjectDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:CustomFieldLinkForProjectData[]'
		)),
		'tns:CustomFieldLinkForProjectData'
	);


	### CustomFieldValueForIssueData
	$l_oServer->wsdl->addComplexType(
		'CustomFieldValueForIssueData',
		'complexType',
		'struct',
		'all',
		'',
		array(
			'field'				=>	array( 'name' => 'field',			'type' => 'tns:ObjectRef'),
			'value'				=>	array( 'name' => 'value',			'type' => 'xsd:string')
		)
	);


	### CustomFieldValueForIssueDataArray
	$l_oServer->wsdl->addComplexType(
		'CustomFieldValueForIssueDataArray',
		'complexType',
		'array',
		'',
		'SOAP-ENC:Array',
		array(),
		array(array(
			'ref'				=> 'SOAP-ENC:arrayType',
			'wsdl:arrayType'	=> 'tns:CustomFieldValueForIssueData[]'
		)),
		'tns:CustomFieldValueForIssueData'
	);


	###
	###  PUBLIC METHODS
	###

	### mc_version
	$l_oServer->register( 'mc_version',
		array(),
		array(
			'return'	=>	'xsd:string'
		),
		$t_namespace
	);


	###
	###  PUBLIC METHODS (defined in mc_enum_api.php)
	###

	### mc_enum_status
	$l_oServer->register( 'mc_enum_status',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for statuses.'
	);

	### mc_enum_priorities
	$l_oServer->register( 'mc_enum_priorities',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for priorities.'
	);

	### mc_enum_severities
	$l_oServer->register( 'mc_enum_severities',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for severities.'
	);

	### mc_enum_reproducibilities
	$l_oServer->register( 'mc_enum_reproducibilities',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for reproducibilities.'
	);

	### mc_enum_projections
	$l_oServer->register( 'mc_enum_projections',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for projections.'
	);

	### mc_enum_etas
	$l_oServer->register( 'mc_enum_etas',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for ETAs.'
	);

	### mc_enum_resolutions
	$l_oServer->register( 'mc_enum_resolutions',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for resolutions.'
	);

	### mc_enum_access_levels
	$l_oServer->register( 'mc_enum_access_levels',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for access levels.'
	);

	### mc_enum_project_status
	$l_oServer->register( 'mc_enum_project_status',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for project statuses.'
	);

	### mc_enum_project_view_states
	$l_oServer->register( 'mc_enum_project_view_states',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for project view states.'
	);

	### mc_enum_view_states
	$l_oServer->register( 'mc_enum_view_states',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for view states.'
	);

	### mc_enum_custom_field_types
	$l_oServer->register( 'mc_enum_custom_field_types',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ObjectRefArray'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for custom field types.'
	);

	### mc_enum_get (should vanish as it has been replaced by more-high level versions)
	$l_oServer->register( 'mc_enum_get',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'enumeration'	=>	'xsd:string'
		),
		array(
			'return'	=>	'xsd:string'
		),
		$t_namespace,
		false, false, false,
		'Get the enumeration for the specified enumeration type.'
	);


	###
	###  PUBLIC METHODS (defined in mc_issue_api.php)
	###

	### mc_issue_exists
	$l_oServer->register( 'mc_issue_exists',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'issue_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'xsd:boolean'
		),
		$t_namespace,
		false, false, false,
		'Check there exists an issue with the specified id.'
	);

	### mc_issue_get
	$l_oServer->register( 'mc_issue_get',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'issue_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:IssueData'
		),
		$t_namespace,
		false, false, false,
		'Get the issue with the specified id.'
	);

	### mc_issue_get_biggest_id
	$l_oServer->register( 'mc_issue_get_biggest_id',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'project_id'=>	'xsd:integer'
		),
		array(
			'return'	=>	'xsd:integer'
		),
		$t_namespace,
		false, false, false,
		'Get the latest submitted issue in the specified project.'
	);

	### mc_issue_get_id_from_summary (should be replaced with a more general search that returns matching issues directly)
	$l_oServer->register( 'mc_issue_get_id_from_summary',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'summary'	=>	'xsd:string'
		),
		array(
			'return'	=>	'xsd:integer'
		),
		$t_namespace,
		false, false, false,
		'Get the id of the issue with the specified summary.'
	);

	### mc_issue_add
	$l_oServer->register( 'mc_issue_add',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'issue'		=>	'tns:IssueData'
		),
		array(
			'return'	=>	'xsd:integer'
		),
		$t_namespace,
		false, false, false,
		'Submit the specified issue details.'
	);

	### mc_issue_delete
	$l_oServer->register( 'mc_issue_delete',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'issue_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'xsd:boolean'
		),
		$t_namespace,
		false, false, false,
		'Delete the issue with the specified id.'
	);

	### mc_issue_note_add
 	$l_oServer->register( 'mc_issue_note_add',
 		array(
			'username'	=>	'xsd:string',
 			'password'	=>	'xsd:string',
 			'issue_id'	=>	'xsd:integer',
 			'note' 		=>	'tns:IssueNoteData'
 		),
 		array(
			'return'	=>	'xsd:integer'
		),
 		$t_namespace,
		false, false, false,
		'Submit a new note.'
 	);

	### mc_issue_note_delete
	$l_oServer->register( 'mc_issue_note_delete',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string',
			'issue_note_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'xsd:boolean'
		),
		$t_namespace,
		false, false, false,
		'Delete the note with the specified id.'
	);


	###
	###  PUBLIC METHODS (defined in mc_project_api.php)
	###

	### mc_projects_get_user_accessible
	$l_oServer->register( 'mc_projects_get_user_accessible',
		array(
			'username'	=>	'xsd:string',
			'password'	=>	'xsd:string'
		),
		array(
			'return'	=>	'tns:ProjectDataArray'
		),
		$t_namespace,
		false, false, false,
		'Get the list of projects that are accessible to the logged in user.'
	);

	### mc_project_get_categories
	$l_oServer->register( 'mc_project_get_categories',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'project_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:StringArray'
		),
		$t_namespace,
		false, false, false,
		'Get the categories belonging to the specified project.'
	);

	### mc_project_get_versions
	$l_oServer->register( 'mc_project_get_versions',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'project_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:ProjectVersionDataArray'
		),
		$t_namespace,
		false, false, false,
		'Get the versions belonging to the specified project.'
	);

	### mc_project_get_released_versions
	$l_oServer->register( 'mc_project_get_released_versions',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'project_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:ProjectVersionDataArray'
		),
		$t_namespace,
		false, false, false,
		'Get the released versions that belong to the specified project.'
	);

	### mc_project_get_unreleased_versions
	$l_oServer->register( 'mc_project_get_unreleased_versions',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'project_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:ProjectVersionDataArray'
		),
		$t_namespace,
		false, false, false,
		'Get the unreleased version that belong to the specified project.'
	);


	###
	###  PUBLIC METHODS (defined in mc_filter_api.php)
	###

	### mc_filter_get
	$l_oServer->register( 'mc_filter_get',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'project_id'	=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:FilterDataArray'
		),
		$t_namespace,
		false, false, false,
		'Get the filters defined for the specified project.'
	);

	### mc_filter_get_issues
	$l_oServer->register( 'mc_filter_get_issues',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'filter_id'		=>	'xsd:integer',
			'page_number'	=>	'xsd:integer',
			'per_page'		=>	'xsd:integer'
		),
		array(
			'return'	=>	'tns:IssueDataArray'
		),
		$t_namespace,
		false, false, false,
		'Get the issues that match the specified filter and paging details.'
	);


	### mc_config_get_string
	$l_oServer->register( 'mc_config_get_string',
		array(
			'username'		=>	'xsd:string',
			'password'		=>	'xsd:string',
			'config_var'	=>	'xsd:string'
		),
		array(
			'return'	=>	'xsd:string'
		),
		$t_namespace,
		false, false, false,
		'Get the value for the specified configuration variable.'
	);

	###
	###  IMPLEMENTATION
	###

	/**
	 * Checks if the request for the webservice is a documentation request (eg:
	 * WSDL) or an actual webservice call.
	 *
	 * The implementation of this method is based on soap_server::service().
	 *
	 * @param $p_service    The webservice class instance.
	 * @param $p_data       The input that is based on the post data.
	 */
	function mci_is_webservice_call( $p_service, $p_data )
	{
		global $QUERY_STRING;
		global $_SERVER;

		if ( isset( $_SERVER['QUERY_STRING'] ) ) {
			$t_qs = $_SERVER['QUERY_STRING'];
		} elseif( isset( $GLOBALS['QUERY_STRING'] ) ) {
			$t_qs = $GLOBALS['QUERY_STRING'];
		} elseif( isset( $QUERY_STRING ) && $QUERY_STRING != '' ) {
			$t_qs = $QUERY_STRING;
		}

		if ( isset( $t_qs ) && ereg( 'wsdl', $t_qs ) ){
			return false;
		} elseif ( $p_data == '' && $p_service->wsdl ) {
			return false;
		} else {
			return true;
		}
 	}

	# pass incoming (posted) data
	if ( isset( $HTTP_RAW_POST_DATA ) ) {
		$t_input = $HTTP_RAW_POST_DATA;
	} else {
		$t_input = implode( "\r\n", file( 'php://input' ) );
	}

	# only include the Mantis / MantisConnect related files, if the current
 	# request is a webservice call (rather than webservice documentation request,
 	# eg: WSDL).
	if ( mci_is_webservice_call( $l_oServer, $t_input ) ) {
		require_once( $t_current_dir . 'mc_core.php' );
	}

	# Execute whatever is requested from the webservice.
	$l_oServer->service( $t_input );
?>